package jlk;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.*;

/**
 *  Description of the Class
 *
 *@author     Test
 *@created    13. Oktober 2004
 */
public class GenerateArrays
{
  /**
   *  Description of the Class
   *
   *@author     Test
   *@created    13. Oktober 2004
   */
  public class RandomGenerator
  {

    /**
     *  Description of the Method
     *
     *@param  na1  Description of the Parameter
     *@param  na2  Description of the Parameter
     *@param  na3  Description of the Parameter
     *@param  nb1  Description of the Parameter
     */
    public void init(int na1, int na2, int na3, int nb1)
    {
      random_status_i = 96;
      for (int j = 0; j < 97; j++) {
        double s = 0.0D;
        double t = 0.5D;
        for (int i = 0; i < 24; i++) {
          int mat = (((na1 * na2) % 179) * na3) % 179;
          na1 = na2;
          na2 = na3;
          na3 = mat;
          nb1 = (53 * nb1 + 1) % 169;
          if ((nb1 * mat) % 64 >= 32) {
            s += t;
          }
          t /= 2;
        }

        random_status_u[j] = s;
      }
      random_status_c = 0.021602869033813477D;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    double get()
    {
      double r = random_status_u[random_status_i] - random_status_u[(random_status_i + 33) % 97];
      if (r < (double) 0) {
        r += 1;
      }
      random_status_u[random_status_i--] = r;
      if (random_status_i < 0) {
        random_status_i = 96;
      }
      random_status_c = random_status_c - 0.45623308420181274D;
      if (random_status_c < (double) 0) {
        random_status_c += 0.99999982118606567D;
      }
      r -= random_status_c;
      if (r < (double) 0) {
        r += 1;
      }
      return r;
    }


    private int random_status_i = 0;
    private double random_status_u[] = null;
    private double random_status_c = 0;


    /**
     *  Constructor for the RandomGenerator object
     */
    public RandomGenerator()
    {
      random_status_u = new double[97];
      long msec_now = System.currentTimeMillis();
      long sec_now = msec_now / (long) 1000;
      init((int) (sec_now / (long) 17), (int) (sec_now % (long) 1017), (int) (msec_now / (long) 23), (int) (msec_now % (long) 2023));
    }


    /**
     *  Constructor for the RandomGenerator object
     *
     *@param  na1  Description of the Parameter
     *@param  na2  Description of the Parameter
     *@param  na3  Description of the Parameter
     *@param  nb1  Description of the Parameter
     */
    public RandomGenerator(int na1, int na2, int na3, int nb1)
    {
      random_status_u = new double[97];
      init(na1, na2, na3, nb1);
    }
  }


  /**
   *  Constructor for the GenerateArrays object
   *
   *@param  class_name  Description of the Parameter
   */
  GenerateArrays(String class_name, String application_name)
  {
    int def_chars_count = def_chars.length();
    int ha[] = new int[32];
    int sum = 0;
    RandomGenerator rg = new RandomGenerator();
    String eol = System.getProperty("line.separator");
    PrintStream old_stdout = System.out;
    try {
      PrintStream out_file = new PrintStream(new BufferedOutputStream(new
          FileOutputStream(new File("src/jlk/Matrix" + class_name + ".java"))));
      System.setOut(out_file);
      System.out.println("package jlk;" + eol);
      System.out.println("class Matrix" + class_name + " implements LicenseMatrix" +
                         eol + "{" + eol);
      System.out.println("   private static final String APPLICATION_NAME = \""+application_name+"\";\n");
      System.out.println("   public String getApplicationName() {");
      System.out.println("     return APPLICATION_NAME;");
      System.out.println("   }\n");

      System.out.println("   private static final String[] PERM_ARRAY = {");
      int i;
      for (i = 0; i < 32; i++) {
        String line = "";
        for (int j = 0; j < 64; j++) {
          char c;
          do {
            int n;
            do {
              n = (int) (rg.get() * (double) def_chars_count);
            }
            while (n < 0 || n >= def_chars_count);
            c = def_chars.charAt(n);
          }
          while (line.indexOf(c) >= 0);
          line = String.valueOf(line) + String.valueOf(c);
          sum += c;
        }

        System.out.print(String.valueOf(String.valueOf( (new StringBuffer(
            "      \"")).append(line).append("\""))));
        if (i < 31) {
          System.out.println(",");
        }
        else {
          System.out.println();
          System.out.println("   };");
        }
      }

      System.out.println(String.valueOf(String.valueOf( (new StringBuffer(
          "   private static final int PERM_ARRAY_CHECKSUM = ")).append(sum).
          append(";"))));
      do {
        i = (int) (rg.get() * (double) 64);
      }
      while (i < 0 || i >= 64);
      System.out.println(String.valueOf(String.valueOf( (new StringBuffer(
          "   private static final int ROLL_PERM_ARRAY = ")).append(i).append(
          ";"))));
      for (i = 0; i < 32; i++) {
        ha[i] = -1;
      }

      for (i = 0; i < 32; i++) {
        int n;
        int j;
        do {
          do {
            n = (int) (rg.get() * (double) 32);
          }
          while (n < 0 || n >= 32);
          for (j = 0; j < 32 && ha[j] != n; j++) {
            ;
          }
        }
        while (j != 32);
        ha[i] = n;
      }

      System.out.println();
      System.out.print("   private static final int[] HEX_ARRAY = {");
      for (i = 0; i < 32; i++) {
        if (i % 8 == 0) {
          System.out.println();
          System.out.print("     ");
        }
        System.out.print(" ".concat(String.valueOf(String.valueOf(ha[i]))));
        if (i < 31) {
          System.out.print(",");
        }
      }

      System.out.println();
      System.out.println("   };");
      System.out.println();
      System.out.println(
          "   public String[] getPermArray()" + eol +
          "   {" + eol +
          "      return this.PERM_ARRAY;" + eol +
          "   }" + eol + eol +
          "   public int getPermArrayChecksum()" + eol +
          "   {" + eol +
          "      return this.PERM_ARRAY_CHECKSUM;" + eol +
          "   }" + eol + eol +
          "   public int getRollPermArray()" + eol +
          "   {" + eol +
          "      return this.ROLL_PERM_ARRAY;" + eol +
          "   }" + eol + eol +
          "   public int[] getHexArray()" + eol +
          "   {" + eol +
          "      return this.HEX_ARRAY;" + eol +
          "   }" + eol + "}");
      System.setOut(old_stdout);
      out_file.close();
      System.out.println("License arrays for application " + class_name + " successfully created");
    }
    catch (FileNotFoundException ex) {
      ex.printStackTrace();
    }
  }


  final static int ENTRIES = 32;
  final static int VALUES = 64;
  static String def_chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz[]!@#$%^&|{}";


  /**
   *  Description of the Method
   *
   *@param  args  Description of the Parameter
   */
  public static void main(String args[])
  {
    System.out.print("Enter application name (= class name): ");
    BufferedReader br = new BufferedReader (new InputStreamReader(System.in));
    try {
      String name = br.readLine();

      System.out.print("Enter application description (= application name): ");
      br = new BufferedReader (new InputStreamReader(System.in));

      String description = br.readLine();
      new GenerateArrays(name,description);
    }
    catch (IOException ex) {
      ex.printStackTrace();
    }
  }
}
