package jlk;


import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

import javax.swing.*;
import javax.swing.border.*;

import java.lang.reflect.Method;

import at.tugraz.genome.utils.ListClasses;

/**
 *  Description of the Class
 *
 *@author     Test
 *@created    14. Juni 2005
 */
public class Licenser extends JFrame
{
  /**
   *  Constructor for the Licenser object
   */
  public Licenser()
  {
    jbInit();
    pack();
    setVisible(true);
  }


  private String[] applicationNames = new String[]{};
  private Class[] applicationMatrixClassList = new Class[]{};


  /**
   *  Description of the Method
   */
  private void jbInit()
  {

    //MatrixZeptoVIEW zvDef = new MatrixZeptoVIEW();

    setJMenuBar(mainMenubar);
    setTitle("Licenser");
    setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    getContentPane().setLayout(new BorderLayout(0, 0));
    setSize(682, 456);
    setVisible(false);
    permissionsBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    permissionsBorder.setTitle("Module Permissions");
    indicesBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    indicesBorder.setTitle("Expiration Date Indices");
    expDatesBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    fileMenu.setText("File");
    fileMenu.setActionCommand("File");

    try {
      String[] matrixFileList = new ListClasses().enumerate("jlk.Matrix");
      applicationNames = new String[matrixFileList.length];
      applicationMatrixClassList = new Class[matrixFileList.length];
      for (int i = 0; i < matrixFileList.length; i++) {
        Class cls = Class.forName(matrixFileList[i]);
        applicationMatrixClassList[i] = cls;
        Class[] signature = new Class[]{};
        Method meth = cls.getMethod("getApplicationName", signature);
        Object jUtil = cls.newInstance();
        Object[] params = new Object[]{};
        applicationNames[i] = (String) meth.invoke(jUtil, params);
      }
      LicenseHandler.setLicenseArray((LicenseMatrix) applicationMatrixClassList[0].newInstance());
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    selectAppLicDef = new JComboBox(applicationNames);

    selectAppLicDef.setMaximumSize(new Dimension(250, 23));
    selectAppLicDef.setMinimumSize(new Dimension(250, 23));
    selectAppLicDef.setPreferredSize(new Dimension(250, 23));
    selectAppLicDef.setEditable(false);
    selectAppLicDef.setToolTipText("Selecting the application for generating license key");
    LicDefItemListener lic_def = new LicDefItemListener();
    selectAppLicDef.addItemListener(lic_def);

    mainMenubar.add(fileMenu);
    exitItem.setText("Exit");
    exitItem.setActionCommand("Exit");
    fileMenu.add(exitItem);
    editMenu.setText("Edit");
    editMenu.setActionCommand("Edit");
    mainMenubar.add(editMenu);
    cutItem.setHorizontalTextPosition(SwingConstants.RIGHT);
    cutItem.setText("Cut");
    cutItem.setActionCommand("Cut");
    cutItem.setAccelerator(KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, Event.CTRL_MASK));
    editMenu.add(cutItem);
    copyItem.setHorizontalTextPosition(SwingConstants.RIGHT);
    copyItem.setText("Copy");
    copyItem.setActionCommand("Copy");
    copyItem.setAccelerator(KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, Event.CTRL_MASK));
    editMenu.add(copyItem);
    pasteItem.setHorizontalTextPosition(SwingConstants.RIGHT);
    pasteItem.setText("Paste");
    pasteItem.setActionCommand("Paste");
    pasteItem.setAccelerator(KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, Event.CTRL_MASK));
    editMenu.add(pasteItem);
    lookAndFeelMenu.setText("Look\'n\'Feel");
    lookAndFeelMenu.setActionCommand("Look\'n\'Feel");
    mainMenubar.add(lookAndFeelMenu);
    keyBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    keyBorder.setTitle("License Key I/O");
    mainPanel.setLayout(new GridBagLayout());
    getContentPane().add("Center", mainPanel);
    topPanel.setLayout(new GridLayout(1, 2, 8, 8));
    mainPanel.add(topPanel, new GridBagConstraintsD(0, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(8, 8, 0, 8), 50, 36));
    permissionsPanel.setBorder(permissionsBorder);
    permissionsPanel.setLayout(new GridBagLayout());
    topPanel.add(permissionsPanel);
    JLabel7.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel7.setText("Module 0:");
    permissionsPanel.add(JLabel7, new GridBagConstraintsD(0, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(4, 5, 0, 0), 12, 14));
    JLabel7.setForeground(java.awt.Color.black);
    mode0Group.setLayout(new GridLayout(1, 0, 0, 0));
    permissionsPanel.add(mode0Group, new GridBagConstraintsD(1, 0, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(4, 0, 0, 6), 0, 4));
    JRadioButton27.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton27.setText("No");
    JRadioButton27.setActionCommand("No");
    JRadioButton27.setSelected(true);
    mode0Group.add(JRadioButton27);
    JRadioButton28.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton28.setText("Yes");
    JRadioButton28.setActionCommand("Yes");
    mode0Group.add(JRadioButton28);
    JRadioButton29.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton29.setText("Free");
    JRadioButton29.setActionCommand("Free");
    mode0Group.add(JRadioButton29);
    JRadioButton30.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton30.setText("Demo");
    JRadioButton30.setActionCommand("Demo");
    mode0Group.add(JRadioButton30);
    JLabel8.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel8.setText("Module 1:");
    permissionsPanel.add(JLabel8, new GridBagConstraintsD(0, 1, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel8.setForeground(java.awt.Color.black);
    mode1Group.setLayout(new GridLayout(1, 0, 0, 0));
    permissionsPanel.add(mode1Group, new GridBagConstraintsD(1, 1, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton26.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton26.setText("No");
    JRadioButton26.setActionCommand("No");
    JRadioButton26.setSelected(true);
    mode1Group.add(JRadioButton26);
    JRadioButton31.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton31.setText("Yes");
    JRadioButton31.setActionCommand("Yes");
    mode1Group.add(JRadioButton31);
    JRadioButton32.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton32.setText("Free");
    JRadioButton32.setActionCommand("Free");
    mode1Group.add(JRadioButton32);
    JRadioButton33.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton33.setText("Demo");
    JRadioButton33.setActionCommand("Demo");
    mode1Group.add(JRadioButton33);
    JLabel9.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel9.setText("Module 2:");
    permissionsPanel.add(JLabel9, new GridBagConstraintsD(0, 2, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel9.setForeground(java.awt.Color.black);
    mode2Group.setLayout(new GridLayout(1, 0, 0, 0));
    permissionsPanel.add(mode2Group, new GridBagConstraintsD(1, 2, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton34.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton34.setText("No");
    JRadioButton34.setActionCommand("No");
    JRadioButton34.setSelected(true);
    mode2Group.add(JRadioButton34);
    JRadioButton35.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton35.setText("Yes");
    JRadioButton35.setActionCommand("Yes");
    mode2Group.add(JRadioButton35);
    JRadioButton36.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton36.setText("Free");
    JRadioButton36.setActionCommand("Free");
    mode2Group.add(JRadioButton36);
    JRadioButton37.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton37.setText("Demo");
    JRadioButton37.setActionCommand("Demo");
    mode2Group.add(JRadioButton37);
    JLabel10.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel10.setText("Module 3:");
    permissionsPanel.add(JLabel10, new GridBagConstraintsD(0, 3, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel10.setForeground(java.awt.Color.black);
    mode3Group.setLayout(new GridLayout(1, 0, 0, 0));
    permissionsPanel.add(mode3Group, new GridBagConstraintsD(1, 3, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton38.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton38.setText("No");
    JRadioButton38.setActionCommand("No");
    JRadioButton38.setSelected(true);
    mode3Group.add(JRadioButton38);
    JRadioButton39.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton39.setText("Yes");
    JRadioButton39.setActionCommand("Yes");
    mode3Group.add(JRadioButton39);
    JRadioButton40.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton40.setText("Free");
    JRadioButton40.setActionCommand("Free");
    mode3Group.add(JRadioButton40);
    JRadioButton41.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton41.setText("Demo");
    JRadioButton41.setActionCommand("Demo");
    mode3Group.add(JRadioButton41);
    JLabel11.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel11.setText("Module 4:");
    permissionsPanel.add(JLabel11, new GridBagConstraintsD(0, 4, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel11.setForeground(java.awt.Color.black);
    mode4Group.setLayout(new GridLayout(1, 0, 0, 0));
    permissionsPanel.add(mode4Group, new GridBagConstraintsD(1, 4, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton42.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton42.setText("No");
    JRadioButton42.setActionCommand("No");
    JRadioButton42.setSelected(true);
    mode4Group.add(JRadioButton42);
    JRadioButton43.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton43.setText("Yes");
    JRadioButton43.setActionCommand("Yes");
    mode4Group.add(JRadioButton43);
    JRadioButton44.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton44.setText("Free");
    JRadioButton44.setActionCommand("Free");
    mode4Group.add(JRadioButton44);
    JRadioButton45.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton45.setText("Demo");
    JRadioButton45.setActionCommand("Demo");
    mode4Group.add(JRadioButton45);
    JLabel12.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel12.setText("Module 5:");
    permissionsPanel.add(JLabel12, new GridBagConstraintsD(0, 5, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 4, 0), 12, 14));
    JLabel12.setForeground(java.awt.Color.black);
    mode5Group.setLayout(new GridLayout(1, 0, 0, 0));
    permissionsPanel.add(mode5Group, new GridBagConstraintsD(1, 5, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 4, 6), 0, 4));
    JRadioButton46.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton46.setText("No");
    JRadioButton46.setActionCommand("No");
    JRadioButton46.setSelected(true);
    mode5Group.add(JRadioButton46);
    JRadioButton47.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton47.setText("Yes");
    JRadioButton47.setActionCommand("Yes");
    mode5Group.add(JRadioButton47);
    JRadioButton48.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton48.setText("Free");
    JRadioButton48.setActionCommand("Free");
    mode5Group.add(JRadioButton48);
    JRadioButton53.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton53.setText("Demo");
    JRadioButton53.setActionCommand("Demo");
    mode5Group.add(JRadioButton53);
    indicesPanel.setBorder(indicesBorder);
    indicesPanel.setLayout(new GridBagLayout());
    topPanel.add(indicesPanel);
    JLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel1.setText("Module 0:");
    indicesPanel.add(JLabel1, new GridBagConstraintsD(0, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(4, 5, 0, 0), 12, 14));
    JLabel1.setForeground(java.awt.Color.black);
    index0Group.setLayout(new GridLayout(1, 0, 0, 0));
    indicesPanel.add(index0Group, new GridBagConstraintsD(1, 0, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(4, 0, 0, 6), 0, 4));
    JRadioButton1.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton1.setText("0");
    JRadioButton1.setActionCommand("No");
    JRadioButton1.setSelected(true);
    index0Group.add(JRadioButton1);
    JRadioButton2.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton2.setText("1");
    JRadioButton2.setActionCommand("Yes");
    index0Group.add(JRadioButton2);
    JRadioButton3.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton3.setText("2");
    JRadioButton3.setActionCommand("Free");
    index0Group.add(JRadioButton3);
    JRadioButton4.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton4.setText("None");
    JRadioButton4.setActionCommand("Demo");
    index0Group.add(JRadioButton4);
    JLabel2.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel2.setText("Module 1:");
    indicesPanel.add(JLabel2, new GridBagConstraintsD(0, 1, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel2.setForeground(java.awt.Color.black);
    index1Group.setLayout(new GridLayout(1, 0, 0, 0));
    indicesPanel.add(index1Group, new GridBagConstraintsD(1, 1, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton5.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton5.setText("0");
    JRadioButton5.setActionCommand("No");
    JRadioButton5.setSelected(true);
    index1Group.add(JRadioButton5);
    JRadioButton6.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton6.setText("1");
    JRadioButton6.setActionCommand("Yes");
    index1Group.add(JRadioButton6);
    JRadioButton7.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton7.setText("2");
    JRadioButton7.setActionCommand("Free");
    index1Group.add(JRadioButton7);
    JRadioButton8.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton8.setText("None");
    JRadioButton8.setActionCommand("Demo");
    index1Group.add(JRadioButton8);
    JLabel3.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel3.setText("Module 2:");
    indicesPanel.add(JLabel3, new GridBagConstraintsD(0, 2, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel3.setForeground(java.awt.Color.black);
    index2Group.setLayout(new GridLayout(1, 0, 0, 0));
    indicesPanel.add(index2Group, new GridBagConstraintsD(1, 2, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton9.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton9.setText("0");
    JRadioButton9.setActionCommand("No");
    JRadioButton9.setSelected(true);
    index2Group.add(JRadioButton9);
    JRadioButton10.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton10.setText("1");
    JRadioButton10.setActionCommand("Yes");
    index2Group.add(JRadioButton10);
    JRadioButton11.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton11.setText("2");
    JRadioButton11.setActionCommand("Free");
    index2Group.add(JRadioButton11);
    JRadioButton12.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton12.setText("None");
    JRadioButton12.setActionCommand("Demo");
    index2Group.add(JRadioButton12);
    JLabel4.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel4.setText("Module 3:");
    indicesPanel.add(JLabel4, new GridBagConstraintsD(0, 3, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel4.setForeground(java.awt.Color.black);
    index3Group.setLayout(new GridLayout(1, 0, 0, 0));
    indicesPanel.add(index3Group, new GridBagConstraintsD(1, 3, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton13.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton13.setText("0");
    JRadioButton13.setActionCommand("No");
    JRadioButton13.setSelected(true);
    index3Group.add(JRadioButton13);
    JRadioButton14.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton14.setText("1");
    JRadioButton14.setActionCommand("Yes");
    index3Group.add(JRadioButton14);
    JRadioButton15.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton15.setText("2");
    JRadioButton15.setActionCommand("Free");
    index3Group.add(JRadioButton15);
    JRadioButton16.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton16.setText("None");
    JRadioButton16.setActionCommand("Demo");
    index3Group.add(JRadioButton16);
    JLabel5.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel5.setText("Module 4:");
    indicesPanel.add(JLabel5, new GridBagConstraintsD(0, 4, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 12, 14));
    JLabel5.setForeground(java.awt.Color.black);
    index4Group.setLayout(new GridLayout(1, 0, 0, 0));
    indicesPanel.add(index4Group, new GridBagConstraintsD(1, 4, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 6), 0, 4));
    JRadioButton17.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton17.setText("0");
    JRadioButton17.setActionCommand("No");
    JRadioButton17.setSelected(true);
    index4Group.add(JRadioButton17);
    JRadioButton18.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton18.setText("1");
    JRadioButton18.setActionCommand("Yes");
    index4Group.add(JRadioButton18);
    JRadioButton19.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton19.setText("2");
    JRadioButton19.setActionCommand("Free");
    index4Group.add(JRadioButton19);
    JRadioButton20.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton20.setText("None");
    JRadioButton20.setActionCommand("Demo");
    index4Group.add(JRadioButton20);
    JLabel6.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel6.setText("Module 5:");
    indicesPanel.add(JLabel6, new GridBagConstraintsD(0, 5, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 5, 4, 0), 12, 14));
    JLabel6.setForeground(java.awt.Color.black);
    index5Group.setLayout(new GridLayout(1, 0, 0, 0));
    indicesPanel.add(index5Group, new GridBagConstraintsD(1, 5, 1, 1, 3.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 0, 4, 6), 0, 4));
    JRadioButton21.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton21.setText("0");
    JRadioButton21.setActionCommand("No");
    JRadioButton21.setSelected(true);
    index5Group.add(JRadioButton21);
    JRadioButton22.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton22.setText("1");
    JRadioButton22.setActionCommand("Yes");
    index5Group.add(JRadioButton22);
    JRadioButton23.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton23.setText("2");
    JRadioButton23.setActionCommand("Free");
    index5Group.add(JRadioButton23);
    JRadioButton24.setHorizontalAlignment(SwingConstants.CENTER);
    JRadioButton24.setText("None");
    JRadioButton24.setActionCommand("Demo");
    index5Group.add(JRadioButton24);
    centerPanel.setLayout(new GridBagLayout());
    mainPanel.add(centerPanel, new GridBagConstraintsD(0, 1, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(8, 8, 0, 8), 52, 0));
    expDatesPanel.setBorder(expDatesBorder);
    expDatesPanel.setLayout(new GridBagLayout());
    centerPanel.add(expDatesPanel, new GridBagConstraintsD(0, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 41));
    JLabel17.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel17.setText("Exp Date 0:");
    expDatesPanel.add(JLabel17, new GridBagConstraintsD(0, 0, 1, 1, 1.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    JLabel17.setForeground(java.awt.Color.black);
    date0Field.setText("2000 12 31");
    date0Field.setHorizontalAlignment(SwingConstants.CENTER);
    expDatesPanel.add(date0Field, new GridBagConstraintsD(1, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 12, 0, 12), 8, 0));
    JLabel19.setHorizontalTextPosition(SwingConstants.CENTER);
    JLabel19.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel19.setVerticalAlignment(SwingConstants.TOP);
    JLabel19.setText("YYYY MM DD");
    expDatesPanel.add(JLabel19, new GridBagConstraintsD(1, 1, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.NORTH, java.awt.GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    date1Field.setText("2000 12 31");
    date1Field.setHorizontalAlignment(SwingConstants.CENTER);
    expDatesPanel.add(date1Field, new GridBagConstraintsD(1, 2, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 12, 0, 12), 8, 0));
    JLabel20.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel20.setText("Exp Date 1:");
    expDatesPanel.add(JLabel20, new GridBagConstraintsD(0, 2, 1, 1, 0.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    JLabel20.setForeground(java.awt.Color.black);
    JLabel22.setHorizontalTextPosition(SwingConstants.CENTER);
    JLabel22.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel22.setVerticalAlignment(SwingConstants.TOP);
    JLabel22.setText("YYYY MM DD");
    expDatesPanel.add(JLabel22, new GridBagConstraintsD(1, 3, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.NORTH, java.awt.GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    date2Field.setText("2000 12 31");
    date2Field.setHorizontalAlignment(SwingConstants.CENTER);
    expDatesPanel.add(date2Field, new GridBagConstraintsD(1, 4, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 12, 0, 12), 8, 0));
    JLabel23.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel23.setText("Exp Date 2:");
    expDatesPanel.add(JLabel23, new GridBagConstraintsD(0, 4, 1, 1, 0.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    JLabel23.setForeground(java.awt.Color.black);
    JLabel25.setHorizontalTextPosition(SwingConstants.CENTER);
    JLabel25.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel25.setVerticalAlignment(SwingConstants.TOP);
    JLabel25.setText("YYYY MM DD");
    expDatesPanel.add(JLabel25, new GridBagConstraintsD(1, 5, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.NORTH, java.awt.GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    userIDVersionPanel.setLayout(new GridLayout(2, 1, 0, 8));
    centerPanel.add(userIDVersionPanel, new GridBagConstraintsD(1, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(0, 8, 0, 0), 0, 40));
    userIDPanel.setBorder(userIDBorder);
    userIDPanel.setLayout(new GridBagLayout());
    userIDVersionPanel.add(userIDPanel);
    JLabel28.setHorizontalTextPosition(SwingConstants.CENTER);
    JLabel28.setHorizontalAlignment(SwingConstants.RIGHT);
    JLabel28.setVerticalAlignment(SwingConstants.TOP);
    JLabel28.setText("AA0001 .. zz9999");
    userIDPanel.add(JLabel28, new GridBagConstraintsD(0, 1, 2, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    JLabel27.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel27.setText("Serial #:");
    userIDPanel.add(JLabel27, new GridBagConstraintsD(0, 0, 1, 1, 1.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    JLabel27.setForeground(java.awt.Color.black);
    serialField.setText("cq0037");
    serialField.setHorizontalAlignment(SwingConstants.CENTER);
    userIDPanel.add(serialField, new GridBagConstraintsD(1, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 12, 0, 12), 8, 0));
    versionPanel.setBorder(versionBorder);
    versionPanel.setLayout(new GridBagLayout());
    userIDVersionPanel.add(versionPanel);
    JLabel29.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel29.setText("Number:");
    versionPanel.add(JLabel29, new GridBagConstraintsD(0, 0, 1, 1, 1.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    JLabel29.setForeground(java.awt.Color.black);
    versionField.setText("20");
    versionField.setHorizontalAlignment(SwingConstants.CENTER);
    versionPanel.add(versionField, new GridBagConstraintsD(1, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 12, 0, 12), 16, 0));
    JLabel32.setHorizontalTextPosition(SwingConstants.CENTER);
    JLabel32.setHorizontalAlignment(SwingConstants.CENTER);
    JLabel32.setVerticalAlignment(SwingConstants.TOP);
    JLabel32.setText("0 .. 255");
    versionPanel.add(JLabel32, new GridBagConstraintsD(1, 1, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.NORTH, java.awt.GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    typePanel.setBorder(typeBorder);
    typePanel.setLayout(new GridBagLayout());
    centerPanel.add(typePanel, new GridBagConstraintsD(2, 0, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(0, 8, 0, 0), 0, 0));
    singleUserButton.setHorizontalAlignment(SwingConstants.CENTER);
    singleUserButton.setText("Single-User License");
    singleUserButton.setActionCommand("Yes");
    singleUserButton.setSelected(true);
    typePanel.add(singleUserButton, new GridBagConstraintsD(0, 0, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.WEST, java.awt.GridBagConstraints.NONE, new Insets(4, 8, 0, 0), 0, 0));
    unlimitedNetworkButton.setHorizontalAlignment(SwingConstants.CENTER);
    unlimitedNetworkButton.setText("Unlimited Network License");
    unlimitedNetworkButton.setActionCommand("Yes");
    typePanel.add(unlimitedNetworkButton, new GridBagConstraintsD(0, 1, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.WEST, java.awt.GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    networkUsersButton.setHorizontalAlignment(SwingConstants.CENTER);
    networkUsersButton.setText("Network License for #Users:");
    networkUsersButton.setActionCommand("Yes");
    typePanel.add(networkUsersButton, new GridBagConstraintsD(0, 2, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.WEST, java.awt.GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    networkUsersField.setText("0");
    networkUsersField.setHorizontalAlignment(SwingConstants.CENTER);
    networkUsersField.setEditable(false);
    networkUsersField.setEnabled(false);
    typePanel.add(networkUsersField, new GridBagConstraintsD(1, 2, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 12, 0, 12), 8, 0));
    JLabel13.setText("1 .. 100");
    typePanel.add(JLabel13, new GridBagConstraintsD(1, 3, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.NORTH, java.awt.GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    hostIDCheckBox.setText("Bind License to this Host ID:");
    hostIDCheckBox.setActionCommand("Bind License to this Host ID:");
    typePanel.add(hostIDCheckBox, new GridBagConstraintsD(0, 5, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.WEST, java.awt.GridBagConstraints.NONE, new Insets(0, 13, 0, 0), 0, 0));
    hostIDField.setText("PR2315");
    hostIDField.setHorizontalAlignment(SwingConstants.CENTER);
    hostIDField.setEditable(false);
    hostIDField.setEnabled(false);
    typePanel.add(hostIDField, new GridBagConstraintsD(1, 5, 1, 1, 1.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(0, 12, 0, 12), 8, 0));
    JLabel26.setText("XX####");
    typePanel.add(JLabel26, new GridBagConstraintsD(1, 6, 1, 1, 1.0, 1.0, java.awt.GridBagConstraints.NORTH, java.awt.GridBagConstraints.NONE, new Insets(0, 0, 8, 0), 0, 0));
    JLabel33.setText(" ");
    typePanel.add(JLabel33, new GridBagConstraintsD(0, 4, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    keyPanel.setBorder(keyBorder);
    keyPanel.setLayout(new GridBagLayout());
    mainPanel.add(keyPanel, new GridBagConstraintsD(0, 2, 1, 1, 1.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(8, 8, 8, 8), 197, 0));
    encodeButton.setText("Encode Settings");
    encodeButton.setActionCommand("Encode Settings");
    keyPanel.add(encodeButton, new GridBagConstraintsD(0, 0, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    keyField.setText("1a@Z-fUM7-h^r[-y$@1-kNf^-njwi-JHAr-VSfy");
    keyField.setHorizontalAlignment(SwingConstants.CENTER);
    keyPanel.add(keyField, new GridBagConstraintsD(1, 0, 2, 1, 1.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.BOTH, new Insets(0, 0, 2, 0), 0, 0));
    keyField.setFont(new Font("MonoSpaced", Font.PLAIN, 12));
    decodeButton.setText("Decode Key");
    decodeButton.setActionCommand("Decode Key");
    keyPanel.add(decodeButton, new GridBagConstraintsD(3, 0, 1, 1, 0.0, 1.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    expDatesBorder.setTitle("Expiration Dates");
    userIDBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    userIDBorder.setTitle("User ID");
    versionBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    versionBorder.setTitle("Key Version");
    typeBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    typeBorder.setTitle("License Type");

    appBorder.setTitleFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
    appBorder.setTitle("Choose application");
    appPanel.setBorder(appBorder);
    appPanel.setLayout(new GridBagLayout());
    mainPanel.add(appPanel, new GridBagConstraintsD(0, 3, 1, 1, 1.0, 0.0, java.awt.GridBagConstraints.CENTER, java.awt.GridBagConstraints.HORIZONTAL, new Insets(8, 8, 8, 8), 197, 0));
    appPanel.add(selectAppLicDef,
      new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
      GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1, 1, 1, 5), 0, 0));

    // register listeners

    SymWindow aSymWindow = new SymWindow();
    this.addWindowListener(aSymWindow);
    SymAction lSymAction = new SymAction();
    exitItem.addActionListener(lSymAction);
    encodeButton.addActionListener(lSymAction);
    networkUsersButton.addActionListener(lSymAction);
    unlimitedNetworkButton.addActionListener(lSymAction);
    singleUserButton.addActionListener(lSymAction);
    hostIDCheckBox.addActionListener(lSymAction);
    decodeButton.addActionListener(lSymAction);

    // fill-in Look'n'Feel menu

    try {
      UIManager.LookAndFeelInfo[] info = UIManager.getInstalledLookAndFeels();
      int count = info.length;
      LookAndFeelAction laf_action = new LookAndFeelAction();

      for (int i = 0; i < count; i++) {
        JMenuItem menu_item = new JMenuItem();
        menu_item.setText(info[i].getName());
        lookAndFeelMenu.add(menu_item);
        menu_item.addActionListener(laf_action);
      }
    }
    catch (Exception e) {
    }

    // center on-screen


    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (screenSize.width - getSize().width) / 2;
    int y = (int) ((screenSize.height - getSize().height) / 2.5);
    setLocation(x, y);
  }


  /**
   *  Description of the Method
   *
   *@param  args  Description of the Parameter
   */
  public static void main(String args[])
  {
    try {
      // re-establish Look'n'Feel from last session

      try {
        int i = Integer.parseInt(valueForKey("LookAndFeel", null));
        UIManager.LookAndFeelInfo[] info = UIManager.getInstalledLookAndFeels();
        int count = info.length;
        if ((i >= 0) && (i < count)) {
          UIManager.setLookAndFeel(info[i].getClassName());
        }
      }
      catch (Exception e) {
      }

      // instantiate app frame

      Licenser licenser = new Licenser();

      // reflect keyField's start-up contents

      licenser.decodeButton_actionPerformed(null);
    }
    catch (Throwable t) {
      t.printStackTrace();
      System.exit(1);
    }
  }


  /**
   *  Description of the Class
   *
   *@author     Test
   *@created    14. Juni 2005
   */
  class LookAndFeelAction implements java.awt.event.ActionListener
  {
    /**
     *  Description of the Method
     *
     *@param  event  Description of the Parameter
     */
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();
      if (object instanceof JMenuItem) {
        JMenuItem menu_item = (JMenuItem) object;

        try {
          String new_name = menu_item.getText();
          String cur_name = UIManager.getLookAndFeel().getName();

          if (new_name != cur_name) {
            UIManager.LookAndFeelInfo[] info = UIManager.getInstalledLookAndFeels();
            int count = info.length;

            for (int i = 0; i < count; i++) {
              if (new_name == info[i].getName()) {
                UIManager.setLookAndFeel(info[i].getClassName());

                JRootPane topRoot = SwingUtilities.getRootPane(mainPanel);
                if (topRoot != null) {
                  while (true) {
                    Container rootParent = topRoot.getParent();
                    if (rootParent == null) {
                      break;
                    }

                    JRootPane possibleRoot = SwingUtilities.getRootPane(rootParent);
                    if (possibleRoot == null || possibleRoot == topRoot) {
                      break;
                    }

                    topRoot = possibleRoot;
                  }
                  SwingUtilities.updateComponentTreeUI(topRoot);
                  if (topRoot.getParent() instanceof Frame) {
                    ((Frame) topRoot.getParent()).pack();
                  }
                }

                setValueForKey("LookAndFeel", Integer.toString(i));
                break;
              }
            }
          }
        }
        catch (Exception e) {
        }
      }
    }
  }


  /**
   *  Notifies this component that it has been added to a container This method
   *  should be called by <code>Container.add</code>, and not by user code
   *  directly. Overridden here to adjust the size of the frame if needed.
   *
   *@see    java.awt.Container#removeNotify
   */
  public void addNotify()
  {
    // Record the size of the window prior to calling parents addNotify.
    Dimension size = getSize();

    super.addNotify();

    if (frameSizeAdjusted) {
      return;
    }
    frameSizeAdjusted = true;

    // Adjust size of frame according to the insets and menu bar
    JMenuBar menuBar = getRootPane().getJMenuBar();
    int menuBarHeight = 0;
    if (menuBar != null) {
      menuBarHeight = menuBar.getPreferredSize().height;
    }
    Insets insets = getInsets();
    setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
  }


  // Used by addNotify
  boolean frameSizeAdjusted = false;

  //{{DECLARE_CONTROLS
  TitledBorder permissionsBorder = new TitledBorder("");
  TitledBorder indicesBorder = new TitledBorder("");
  TitledBorder expDatesBorder = new TitledBorder("");
  TitledBorder userIDBorder = new TitledBorder("");
  TitledBorder versionBorder = new TitledBorder("");
  TitledBorder typeBorder = new TitledBorder("");
  TitledBorder keyBorder = new TitledBorder("");
  TitledBorder appBorder = new TitledBorder("");
  JPanel mainPanel = new JPanel();
  JPanel topPanel = new JPanel();
  JPanel permissionsPanel = new JPanel();
  JLabel JLabel7 = new JLabel();
  JButtonGroupPanel mode0Group = new JButtonGroupPanel();
  JRadioButton JRadioButton27 = new JRadioButton();
  JRadioButton JRadioButton28 = new JRadioButton();
  JRadioButton JRadioButton29 = new JRadioButton();
  JRadioButton JRadioButton30 = new JRadioButton();
  JLabel JLabel8 = new JLabel();
  JButtonGroupPanel mode1Group = new JButtonGroupPanel();
  JRadioButton JRadioButton26 = new JRadioButton();
  JRadioButton JRadioButton31 = new JRadioButton();
  JRadioButton JRadioButton32 = new JRadioButton();
  JRadioButton JRadioButton33 = new JRadioButton();
  JLabel JLabel9 = new JLabel();
  JButtonGroupPanel mode2Group = new JButtonGroupPanel();
  JRadioButton JRadioButton34 = new JRadioButton();
  JRadioButton JRadioButton35 = new JRadioButton();
  JRadioButton JRadioButton36 = new JRadioButton();
  JRadioButton JRadioButton37 = new JRadioButton();
  JLabel JLabel10 = new JLabel();
  JButtonGroupPanel mode3Group = new JButtonGroupPanel();
  JRadioButton JRadioButton38 = new JRadioButton();
  JRadioButton JRadioButton39 = new JRadioButton();
  JRadioButton JRadioButton40 = new JRadioButton();
  JRadioButton JRadioButton41 = new JRadioButton();
  JLabel JLabel11 = new JLabel();
  JButtonGroupPanel mode4Group = new JButtonGroupPanel();
  JRadioButton JRadioButton42 = new JRadioButton();
  JRadioButton JRadioButton43 = new JRadioButton();
  JRadioButton JRadioButton44 = new JRadioButton();
  JRadioButton JRadioButton45 = new JRadioButton();
  JLabel JLabel12 = new JLabel();
  JButtonGroupPanel mode5Group = new JButtonGroupPanel();
  JRadioButton JRadioButton46 = new JRadioButton();
  JRadioButton JRadioButton47 = new JRadioButton();
  JRadioButton JRadioButton48 = new JRadioButton();
  JRadioButton JRadioButton53 = new JRadioButton();
  JPanel indicesPanel = new JPanel();
  JLabel JLabel1 = new JLabel();
  JButtonGroupPanel index0Group = new JButtonGroupPanel();
  JRadioButton JRadioButton1 = new JRadioButton();
  JRadioButton JRadioButton2 = new JRadioButton();
  JRadioButton JRadioButton3 = new JRadioButton();
  JRadioButton JRadioButton4 = new JRadioButton();
  JLabel JLabel2 = new JLabel();
  JButtonGroupPanel index1Group = new JButtonGroupPanel();
  JRadioButton JRadioButton5 = new JRadioButton();
  JRadioButton JRadioButton6 = new JRadioButton();
  JRadioButton JRadioButton7 = new JRadioButton();
  JRadioButton JRadioButton8 = new JRadioButton();
  JLabel JLabel3 = new JLabel();
  JButtonGroupPanel index2Group = new JButtonGroupPanel();
  JRadioButton JRadioButton9 = new JRadioButton();
  JRadioButton JRadioButton10 = new JRadioButton();
  JRadioButton JRadioButton11 = new JRadioButton();
  JRadioButton JRadioButton12 = new JRadioButton();
  JLabel JLabel4 = new JLabel();
  JButtonGroupPanel index3Group = new JButtonGroupPanel();
  JRadioButton JRadioButton13 = new JRadioButton();
  JRadioButton JRadioButton14 = new JRadioButton();
  JRadioButton JRadioButton15 = new JRadioButton();
  JRadioButton JRadioButton16 = new JRadioButton();
  JLabel JLabel5 = new JLabel();
  JButtonGroupPanel index4Group = new JButtonGroupPanel();
  JRadioButton JRadioButton17 = new JRadioButton();
  JRadioButton JRadioButton18 = new JRadioButton();
  JRadioButton JRadioButton19 = new JRadioButton();
  JRadioButton JRadioButton20 = new JRadioButton();
  JLabel JLabel6 = new JLabel();
  JButtonGroupPanel index5Group = new JButtonGroupPanel();
  JRadioButton JRadioButton21 = new JRadioButton();
  JRadioButton JRadioButton22 = new JRadioButton();
  JRadioButton JRadioButton23 = new JRadioButton();
  JRadioButton JRadioButton24 = new JRadioButton();
  JPanel centerPanel = new JPanel();
  JPanel expDatesPanel = new JPanel();
  JLabel JLabel17 = new JLabel();
  JTextField date0Field = new JTextField();
  JLabel JLabel19 = new JLabel();
  JTextField date1Field = new JTextField();
  JLabel JLabel20 = new JLabel();
  JLabel JLabel22 = new JLabel();
  JTextField date2Field = new JTextField();
  JLabel JLabel23 = new JLabel();
  JLabel JLabel25 = new JLabel();
  JPanel userIDVersionPanel = new JPanel();
  JPanel userIDPanel = new JPanel();
  JLabel JLabel28 = new JLabel();
  JLabel JLabel27 = new JLabel();
  JTextField serialField = new JTextField();
  JPanel versionPanel = new JPanel();
  JLabel JLabel29 = new JLabel();
  JTextField versionField = new JTextField();
  JLabel JLabel32 = new JLabel();
  JPanel typePanel = new JPanel();
  JRadioButton singleUserButton = new JRadioButton();
  JRadioButton unlimitedNetworkButton = new JRadioButton();
  JRadioButton networkUsersButton = new JRadioButton();
  JTextField networkUsersField = new JTextField();
  JLabel JLabel13 = new JLabel();
  JCheckBox hostIDCheckBox = new JCheckBox();
  JTextField hostIDField = new JTextField();
  JLabel JLabel26 = new JLabel();
  JLabel JLabel33 = new JLabel();
  JPanel keyPanel = new JPanel();
  JButton encodeButton = new JButton();
  JTextField keyField = new JTextField();
  JButton decodeButton = new JButton();

  JPanel appPanel = new JPanel();

  JMenuBar mainMenubar = new JMenuBar();
  JMenu fileMenu = new JMenu();
  JMenuItem exitItem = new JMenuItem();
  JMenu editMenu = new JMenu();
  JMenuItem cutItem = new JMenuItem();
  JMenuItem copyItem = new JMenuItem();
  JMenuItem pasteItem = new JMenuItem();
  JMenu lookAndFeelMenu = new JMenu();

  String[] items = null;
  //{"SensiChip View 2.1 Release 2x", "ZeptoVIEW Pro 2.0"};
  private JComboBox selectAppLicDef = null;
  //new JComboBox(items);

  //}}

  //{{DECLARE_MENUS
  //}}

  /**
   *  Description of the Method
   */
  void exitApplication()
  {
    try {
      this.setVisible(false);
      // hide the Frame
      this.dispose();
      // free the system resources
      System.exit(0);
      // close the application
    }
    catch (Exception e) {
    }
  }


  /**
   *  Description of the Class
   *
   *@author     Test
   *@created    14. Juni 2005
   */
  class SymWindow extends java.awt.event.WindowAdapter
  {
    /**
     *  Description of the Method
     *
     *@param  event  Description of the Parameter
     */
    public void windowClosing(java.awt.event.WindowEvent event)
    {
      Object object = event.getSource();
      if (object == Licenser.this) {
        Licenser_windowClosing(event);
      }
    }
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void Licenser_windowClosing(java.awt.event.WindowEvent event)
  {
    exitApplication();
  }


  /**
   *  Description of the Class
   *
   *@author     Test
   *@created    14. Juni 2005
   */
  class SymAction implements java.awt.event.ActionListener
  {
    /**
     *  Description of the Method
     *
     *@param  event  Description of the Parameter
     */
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      Object object = event.getSource();
      if (object == exitItem) {
        exitItem_actionPerformed(event);
      }

      if (object == encodeButton) {
        encodeButton_actionPerformed(event);
      } else if (object == networkUsersButton) {
        networkUsersButton_actionPerformed(event);
      } else if (object == unlimitedNetworkButton) {
        unlimitedNetworkButton_actionPerformed(event);
      } else if (object == singleUserButton) {
        singleUserButton_actionPerformed(event);
      } else if (object == hostIDCheckBox) {
        hostIDCheckBox_actionPerformed(event);
      } else if (object == decodeButton) {
        decodeButton_actionPerformed(event);
      }
    }
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void exitItem_actionPerformed(java.awt.event.ActionEvent event)
  {
    exitApplication();
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void singleUserButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    singleUserButton.setSelected(true);
    unlimitedNetworkButton.setSelected(false);
    networkUsersButton.setSelected(false);

    networkUsersField.setEditable(false);
    networkUsersField.setEnabled(false);
    networkUsersField.setText("0");
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void unlimitedNetworkButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    singleUserButton.setSelected(false);
    unlimitedNetworkButton.setSelected(true);
    networkUsersButton.setSelected(false);

    networkUsersField.setEditable(false);
    networkUsersField.setEnabled(false);
    networkUsersField.setText("0");
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void networkUsersButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    singleUserButton.setSelected(false);
    unlimitedNetworkButton.setSelected(false);
    networkUsersButton.setSelected(true);

    networkUsersField.setEditable(true);
    networkUsersField.setEnabled(true);
    networkUsersField.selectAll();
    networkUsersField.requestFocus();
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void hostIDCheckBox_actionPerformed(java.awt.event.ActionEvent event)
  {
    if (hostIDCheckBox.isSelected()) {
      hostIDField.setEditable(true);
      hostIDField.setEnabled(true);
      hostIDField.selectAll();
      hostIDField.requestFocus();
    } else {
      hostIDField.setEditable(false);
      hostIDField.setEnabled(false);
      hostIDField.setText("AA0000");
    }
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void encodeButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    LicenseDefExt licenseDef = new LicenseDefExt();
    int i;
    int col;

    // Assign values for the mode (module) and index (date reference) popups.

    licenseDef.setMode(0, getSelectedColumn(mode0Group));
    licenseDef.setMode(1, getSelectedColumn(mode1Group));
    licenseDef.setMode(2, getSelectedColumn(mode2Group));
    licenseDef.setMode(3, getSelectedColumn(mode3Group));
    licenseDef.setMode(4, getSelectedColumn(mode4Group));
    licenseDef.setMode(5, getSelectedColumn(mode5Group));

    col = getSelectedColumn(index0Group);
    licenseDef.setExpDateIndex(0, (col > 2) ? -1 : col);
    col = getSelectedColumn(index1Group);
    licenseDef.setExpDateIndex(1, (col > 2) ? -1 : col);
    col = getSelectedColumn(index2Group);
    licenseDef.setExpDateIndex(2, (col > 2) ? -1 : col);
    col = getSelectedColumn(index3Group);
    licenseDef.setExpDateIndex(3, (col > 2) ? -1 : col);
    col = getSelectedColumn(index4Group);
    licenseDef.setExpDateIndex(4, (col > 2) ? -1 : col);
    col = getSelectedColumn(index5Group);
    licenseDef.setExpDateIndex(5, (col > 2) ? -1 : col);

    // Check whether the dates entered are valid.
    // The proper format is "YYYY MM DD", or "-" if undefined.

    try {
      licenseDef.setExpDate(0, new ExpDate(date0Field.getText()));
    }
    catch (Exception e) {
      errSelectField(date0Field);
      return;
    }
    if (!licenseDef.getExpDate(0).isDefined()) {
      for (i = 0; i < 6; i++) {
        if (licenseDef.getExpDateIndex(i) == 0) {
          errSelectField(date0Field);
          return;
        }
      }
    }

    try {
      licenseDef.setExpDate(1, new ExpDate(date1Field.getText()));
    }
    catch (Exception e) {
      errSelectField(date1Field);
      return;
    }
    if (!licenseDef.getExpDate(1).isDefined()) {
      for (i = 0; i < 6; i++) {
        if (licenseDef.getExpDateIndex(i) == 1) {
          errSelectField(date1Field);
          return;
        }
      }
    }

    try {
      licenseDef.setExpDate(2, new ExpDate(date2Field.getText()));
    }
    catch (Exception e) {
      errSelectField(date2Field);
      return;
    }
    if (!licenseDef.getExpDate(2).isDefined()) {
      for (i = 0; i < 6; i++) {
        if (licenseDef.getExpDateIndex(i) == 2) {
          errSelectField(date2Field);
          return;
        }
      }
    }

    // Checks to see if the User ID (aka serial number) is valid.
    // The User ID is a combo of two characters plus four digits,
    // from 'AA0001' to 'zz9999'. The characters are case-sensitive.

    try {
      licenseDef.setUserID(serialField.getText());
    }
    catch (Exception e) {
      errSelectField(serialField);
      return;
    }

    // Checks to see if the version number is valid.
    // The proper value is 0 to 255.

    try {
      licenseDef.setVersion(Integer.parseInt(versionField.getText()));
    }
    catch (Exception e) {
      errSelectField(versionField);
      return;
    }

    // Obtain Max Users. Possible values are 0 (single-user license),
    // 1..100 (network license for 1..100 users), or 101 (unlimited
    // network license).

    int max_users;

    if (singleUserButton.isSelected()) {
      max_users = 0;
    } else if (unlimitedNetworkButton.isSelected()) {
      max_users = 101;
    } else {
      max_users = 0;
      try {
        max_users = Integer.parseInt(networkUsersField.getText());
      }
      catch (Exception e) {
        errSelectField(networkUsersField);
        return;
      }
      if ((max_users < 1) || (max_users > 100)) {
        errSelectField(networkUsersField);
        return;
      }
    }

    try {
      licenseDef.setMaxUsers(max_users);
    }
    catch (Exception e) {
      Toolkit.getDefaultToolkit().beep();
      return;
    }

    // Obtain Host ID. Possible values are 0 (i.e. not bound to Host ID),
    // or a Host ID number in 1..1023 range, extracted from the "XX####"
    // Host ID string via HostID.decodeHostID().

    int host_id;

    if (hostIDCheckBox.isSelected()) {
      try {
        host_id = HostID.decodeHostID(hostIDField.getText());
      }
      catch (Exception e) {
        errSelectField(hostIDField);
        return;
      }
    } else {
      host_id = 0;
    }

    try {
      licenseDef.setHostID(host_id);
    }
    catch (Exception e) {
      Toolkit.getDefaultToolkit().beep();
      return;
    }

    // Check and encode the license settings.

    String string = "<invalid>";
    try {
      string = licenseDef.encode();
    }
    catch (Exception e) {
      Toolkit.getDefaultToolkit().beep();
    }
    keyField.setText(string);
    keyField.selectAll();
    keyField.requestFocus();
  }


  /**
   *  Description of the Method
   *
   *@param  event  Description of the Parameter
   */
  void decodeButton_actionPerformed(java.awt.event.ActionEvent event)
  {
    LicenseDef ld = new LicenseDef();

    try {
      ld.decode(keyField.getText());
      reflectLicenseDef(ld);
    }
    catch (Exception e) {
      errSelectField(keyField);
    }
  }


  /**
   *  Description of the Class
   *
   *@author     Test
   *@created    14. Juni 2005
   */
  class LicDefItemListener implements ItemListener
  {
    // This method is called only if a new item has been selected.


    /**
     *  Description of the Method
     *
     *@param  evt  Description of the Parameter
     */
    public void itemStateChanged(ItemEvent evt)
    {

      int item = selectAppLicDef.getSelectedIndex();

      try {
        LicenseHandler.setLicenseArray((LicenseMatrix) applicationMatrixClassList[item].newInstance());
        //System.out.println(classList[item].newInstance());
      }
      catch (Exception ex) {
      }

      /*
       *  switch (item) {
       *  case 0: {
       *  def = new MatrixZeptoVIEW();
       *  break;
       *  }
       *  case 1: {
       *  def = new MatrixZeptoVIEWPro();
       *  break;
       *  }
       *  }
       */
    }
  }


  /**
   *  Description of the Method
   *
   *@param  licenseDef  Description of the Parameter
   */
  void reflectLicenseDef(LicenseDef licenseDef)
  {
    int max_users = licenseDef.getMaxUsers();
    int host_id = licenseDef.getHostID();
    int index;

    // Set mode*Group and index*Group selections.

    setSelectedColumn(mode0Group, licenseDef.getMode(0));
    setSelectedColumn(mode1Group, licenseDef.getMode(1));
    setSelectedColumn(mode2Group, licenseDef.getMode(2));
    setSelectedColumn(mode3Group, licenseDef.getMode(3));
    setSelectedColumn(mode4Group, licenseDef.getMode(4));
    setSelectedColumn(mode5Group, licenseDef.getMode(5));

    index = licenseDef.getExpDateIndex(0);
    setSelectedColumn(index0Group, (index < 0) ? 3 : index);
    index = licenseDef.getExpDateIndex(1);
    setSelectedColumn(index1Group, (index < 0) ? 3 : index);
    index = licenseDef.getExpDateIndex(2);
    setSelectedColumn(index2Group, (index < 0) ? 3 : index);
    index = licenseDef.getExpDateIndex(3);
    setSelectedColumn(index3Group, (index < 0) ? 3 : index);
    index = licenseDef.getExpDateIndex(4);
    setSelectedColumn(index4Group, (index < 0) ? 3 : index);
    index = licenseDef.getExpDateIndex(5);
    setSelectedColumn(index5Group, (index < 0) ? 3 : index);

    // Set date*Field strings.

    date0Field.setText(licenseDef.getExpDate(0).toString());
    date1Field.setText(licenseDef.getExpDate(1).toString());
    date2Field.setText(licenseDef.getExpDate(2).toString());

    // Set user ID and key version.

    serialField.setText(licenseDef.getUserID());

    java.text.DecimalFormat df = new java.text.DecimalFormat("000");
    versionField.setText(df.format(licenseDef.getVersion()));

    // Reflect max_users value.

    if (max_users == 0) {
      singleUserButton_actionPerformed(null);
    } else if (max_users == 101) {
      unlimitedNetworkButton_actionPerformed(null);
    } else {
      networkUsersButton_actionPerformed(null);
      networkUsersField.setText(Integer.toString(max_users));
    }

    // Reflect host_id value.

    hostIDCheckBox.setSelected(host_id != 0);
    hostIDCheckBox_actionPerformed(null);
    hostIDField.setText(HostID.encodeHostID(host_id));
  }


  /**
   *  Gets the selectedColumn attribute of the Licenser object
   *
   *@param  panel  Description of the Parameter
   *@return        The selectedColumn value
   */
  protected int getSelectedColumn(JButtonGroupPanel panel)
  {
    int i;
    Enumeration e;

    for (i = 0, e = panel.getElements(); e.hasMoreElements(); i++) {
      if (((AbstractButton) (e.nextElement())).isSelected()) {
        return i;
      }
    }

    return -1;
  }


  /**
   *  Sets the selectedColumn attribute of the Licenser object
   *
   *@param  panel        The new selectedColumn value
   *@param  columnIndex  The new selectedColumn value
   */
  protected void setSelectedColumn(JButtonGroupPanel panel, int columnIndex)
  {
    int i;
    Enumeration e;

    for (i = 0, e = panel.getElements(); e.hasMoreElements(); i++) {
      AbstractButton button = (AbstractButton) (e.nextElement());
      if (i == columnIndex) {
        panel.setSelection(button, true);
        return;
      }
    }
  }


  /**
   *  Description of the Method
   *
   *@param  field  Description of the Parameter
   */
  protected void errSelectField(JTextField field)
  {
    Toolkit.getDefaultToolkit().beep();
    field.selectAll();
    field.requestFocus();
  }


  /**
   *  Description of the Method
   *
   *@param  aKey          Description of the Parameter
   *@param  defaultValue  Description of the Parameter
   *@return               Description of the Return Value
   */
  public static String valueForKey(String aKey, String defaultValue)
  {
    try {
      Properties props = new Properties();
      File file = new File(System.getProperty("user.dir"), "Licenser.properties");

      FileInputStream in = new FileInputStream(file);
      props.load(in);
      in.close();

      String value = props.getProperty(aKey);
      if (value != null) {
        return value;
      }
    }
    catch (Exception e) {
    }
    return defaultValue;
  }


  /**
   *  Sets the valueForKey attribute of the Licenser class
   *
   *@param  aKey    The new valueForKey value
   *@param  aValue  The new valueForKey value
   */
  public static void setValueForKey(String aKey, String aValue)
  {
    try {
      Properties props = new Properties();
      File file = new File(System.getProperty("user.dir"), "Licenser.properties");

      try {
        FileInputStream in = new FileInputStream(file);
        props.load(in);
        in.close();
      }
      catch (Exception e) {
      }

      props.put(aKey, aValue);

      FileOutputStream out = new FileOutputStream(file);
      //props.save(out, null);
      props.store(out, null);
      out.close();

    }
    catch (Exception e) {
    }
  }
}
