package jlk;

public class MatrixLipidDataAnalyzer implements LicenseMatrix
{

   private static final String APPLICATION_NAME = "Lipid Data Analyzer";

   public String getApplicationName() {
     return APPLICATION_NAME;
   }

   private static final String[] PERM_ARRAY = {
      "R^Y%IwCk6e0XuKsyW9d3OvMlBm|f2USzQtJi7]4Th8!Da{G5br}pNZ#EqAn1Po@L",
      "fE4XYDq!MOiU90BaKxNQ$vcl|km@F]SJsI8gPTtHrRo3dep&71[%^5bzw}yGuWn#",
      "C2[So71QGvgr#An$6YdTK]&HJDR|s4!BhFL5}%qZIOzXacu^lbpeNV{t8iyW3E0@",
      "bseoN9ZH6%I2qj7[yLWER$fDunCPG8z#K1{Bia]YVX0wmQUMJ!xt3d@SO&|r^hk4",
      "pk{$OBq%NbDjV#3vrHQuKih[AyWtC6SoEgYaJ0fc!}7IPd4@|9T8FXslmM1LGzeR",
      "BQzU[P417Wh#Vlm05NxEYGn!Dic^kJCwy]dTFSZrfAI8o|MHquvXeat$&@6Lj9%g",
      "cMGQSwrjz5AhV%itTX^HIB6$8g]}{oZ[R71U3DEkqbKdp@LWeOn|sYaNFu2#9flJ",
      "&fj2}TxEmlFyR7Xrn$IA69su54{D|[1dpc3ZO!bL0V]GMCY^zQgBeS@%wK#khiPN",
      "B9{oSAc3w7^du$]qI!|xPkfpvC6#Y}JiyVrbsQ2FULg1mW5GKTRe4Hzl0DNOMX%E",
      "@idfa{Plb&7O}Fsv[R]cuUW0G8t%mh9QBo#H214YK5!3MrjC6kZpwVqnAJ|DENzS",
      "J$YCaLdoheEMx9T60fH4U#%zW@7IP8ijDrbq[tGQZ^52B]Kywm{Sc}NFps!&nVkg",
      "|I!PiwUqF}@2D1n8JyT[4jv0mKBo3hlL9NxMR&cdaCtk7{SVsrQ5^]OpW$Z%#6XA",
      "]TdfP@qxntop89QyNMX6|U^h2wBE5Km[1WOg3sY4%VDkFrIj&7L0beZHuSa#i}z!",
      "Eh8J9@7v]q#[ud5IS0{VmYTbtp|3FQ6igXRnLfDeM&rjyPW^Cx%AZlkUKz4scN}G",
      "0pRLl9DMwiY!cvEOPHg3J14[thBCU@VW&e7yAZ2QdS%akurnXm^zT5{q6fsG]bNj",
      "$GwS4RpDNH6}j5seBP@T^8ciJ[akX3oxf|IZO#EQ0AFvWKnd&]2{rmUqygMut1LY",
      "uIcbpjfJUo|KEiZsR!V8@#vCm9gHyXzYkG0On}SqL7PWQ1DdaTxBr[l4tw6$e{MN",
      "GC]Z%3#4g!xvSM9dLDbVjQcX^EK[@0aTBNkmJzy{W|uYIePohwil1pqtFR2&n8}6",
      "ZYNcml3d{tPR0iDXry&1Q@pT$HV2!LJ8^|#oWA97C}xhfknbUwSIgq6Kvs4BMEj[",
      "mk@p7$l{AfaNe0wq2u^oHDgxT%|FXGBh8OPr4bzUR!CVWj&[Ii3KyQtsYZd}vnM]",
      "@jwU8et$nfVZYrFdm&b1TC4{[O^WH2kJzo3vIKhANEa]R0B!gLuPy|X#GM69xDcs",
      "WZTJm$u|K23NxpRvAyhodC17fO4L&!6FkrGezUEwYi]HsQtMaP{XB5[b@%}SD9jn",
      "rNvd6uc3U!JILq%Ta^7lK#em{hWY$9w&5812@pFXOiSVtQBoR]kEzxMys}HgfjZ[",
      "ixW6[XQ]Kzq{PJj}DM2w$A3vla!f5phe1^ZnOGbRmEUTI4BtgS0yF8LN#%do7|CV",
      "Xvo4j#$shtxOKVY18[Um!Z^F&QA6RNd0n|beg@a3}9kS2TcDp5rB%f]IHil7zECL",
      "a#XDsrBGNRJc[1zuVAo6^pUdeQymPS{T4v&5xhMEWtI0F!q@LwO8lnKH92$gk3fb",
      "%Vynxk|$!}ptU5Pd0WX&jqT8mZOFs7IhNMEfRorg]LHS{bv[Alu^@DGecz3YQ26B",
      "xzq5@8o4}IZFBa^1yX%Nc&|3h[{#gVHfeAdSYjTKpnPbD]lO2LJuC0Wt$mG9irw7",
      "#VKbGe}9nMpB1rDxL2SsZm7vWXh$5&awEzTJHAicfYkoFQu^[Ntg!lUI68yjCOd{",
      "I6L@RyDYS$V^aGqTuW#z9cZx2ke0OmAjsp7K}n8X{B!NEvdQ&]Mog|tr3l[1Hh4i",
      "$i[f5!d2r|MzLxwW0N3uyCGoUHEOTaDVY]gsvF%m{}KAcBp1PqlXj@8ZJR&htb6I",
      "E3B[9e!r8Q4h5SNcdHx&^DICpw7RzmsLWbX}a]|qOJvgu2k#6G$YZA0nfFTy{@KU"
   };
   private static final int PERM_ARRAY_CHECKSUM = 174337;
   private static final int ROLL_PERM_ARRAY = 21;

   private static final int[] HEX_ARRAY = {
      3, 31, 30, 12, 25, 4, 15, 7,
      21, 22, 2, 9, 8, 17, 11, 13,
      16, 24, 26, 10, 23, 19, 29, 20,
      0, 18, 28, 27, 5, 14, 1, 6
   };

   public String[] getPermArray()
   {
      return this.PERM_ARRAY;
   }

   public int getPermArrayChecksum()
   {
      return this.PERM_ARRAY_CHECKSUM;
   }

   public int getRollPermArray()
   {
      return this.ROLL_PERM_ARRAY;
   }

   public int[] getHexArray()
   {
      return this.HEX_ARRAY;
   }
}
