package jlk;

/**
 * <p>Title: ZeptoVIEW Licenser</p>
 * <p>Description: Special Licenser for ZeptoVIEW</p>
 * <p>Copyright: Copyright (c) 1999</p>
 * <p>Company: TU - Graz</p>
 * @author Robert Molidor
 * @version
 */

class MatrixZeptoVIEWPro implements LicenseMatrix{

  private static final String APPLICATION_NAME = "ZeptoVIEW Pro 2.0";

  public String getApplicationName() {
    return APPLICATION_NAME;
  }
  //ZeptoVIEW Pro 2.0 Release 2
  private static final String[] PERM_ARRAY = {
    "&lig0HmTNLEr%aFS]5c|B!2Z@z4A7ns}KDkQeX$ObIo6vqjJU3Ru8^x1{y9PW[#G",
    "^lvoE{8KBZsM6pWFmqOgeNY[Vx]&PXTCAntyGQ3k|zuJ}9H$I7%1!SUcw5LjiRdD",
    "cNu4i]5Gq&ZwoD}[UOsF3VzH6BCW%7!Mt{2SIh#x8XjP$plgaYeRykv@J9dm0T|^",
    "swM!9@Nem548aThf[2kVbSKt|%LIxWilYU{DdJGyzE1Avpqn$Qg3jBuF7}6c^]0C",
    "bLG6Q4|dz5aFWy71hmUtfST#90j8!@CKxcprAo3Z^VDYXgJ]qOl[Rew$iN}kuMBP",
    "J!TGndbH5&iVSzvM0fZ9kpPjXwDI2xtr6ECuL|8ma{}g%^[OY]4WKcFlN1hABoy@",
    "P2%dxSqUNcFaXye{#umC4o^Mn6k|98EJ}1[v$j&LV]wZtfrYgD3KsOpHR0G7hWlb",
    "K$lfJt^dEeXk8S1PQ2qbamB3nz7LT0|uig{AhVy&6soNrM!x]#}O@FZC[w%Rjp4W",
    "bElizj6nGqa}d5IXwKy$W%e[LVT1|SCPpr9MDvkx7oZRs&@m48JO{AUNH0Bu^hY2",
    "!Z#l]yRtHr4{wWGs6iNeQ9Tj|%n}I8@7UFOkgP&5$Kvh[DVfEbL^zAp3cYCx12Sa",
    "1ByNcw7Q4jHa^560%A&iuhvV$ETFJepl]Y|xSnUXI!qZ#od3z8[OCGKktRf9DW@m",
    "JU4#Lz@dQskHfm3T&Z1i%yx6v7l5B]KY9RAX[0FD|weouMIgh2cqnCPj$}8rtbO!",
    "o}9W![xb$B3YEU1QM675PnR8a2{Vh#sOkerT4J0y|pAjcN&H]^S@fGlZvX%LIqzK",
    "EpFkBLPK]O7n1%MH4G^wg{ofy58YceqmjAh!dDa60zUR|#&vbV3JrTu2I@NCQt[X",
    "xGg[t9zfTcM%3wXq5K2Lpk!ySa0{P]s$@m#7nv1ho}Oe|VdRNFj8YC4ZDQr^AUlW",
    "Wx!G1wCYroSm2u%v&FIVf]X9pjlbTBcEkaPyqnU|K7$3e@AH0h[ZD{g68}N5iJdt",
    "[RVxJf{B&1Iu3qsdX!vi|omMc52TS@t$KZ7NpleQ0UrWCgP8kFOhajY9HDnGb#wy",
    "lwILE}g1bz^p5OBQNU#!DS9vTukRMq24]|X&[Vae87xWyhG%PnYc0A6f$os{HKJF",
    "HrpfZ%50mA!6PedX[DhMn}aYBzyVO$olLT]uvSCExcg{k4jJ3FW1KsItQ2G9i8#@",
    "PADai1Fl!9{xU%hXgo&bYZ4#|QGn}5^670Hd@VLJwfMSBpz8jrR3OqEKue]tyI2N",
    "bY6HnmS9f}QEKvNJ&W!UZh^{yr#t|wPIuTLD]z3O8q04RjFCGxVAad[%sB5kcM$g",
    "zIeYBdwftyL!uMb5|ch@$#AjOPEFpUqTDmHnQ1l}3Ro4%8rvxgJis{]^07Z6[CW9",
    "&c$zISjF}7%fLr#ZMbm8He5TplYOaNq4CR{1W2dkE0!X|UuoKB]sxJ^DA3@QPh9i",
    "Mc^avZxuzTI&3JtlYsp|8ydPCbnB4rEAqG[m5KNF6!j$WoD]2LX%fwQeVSiO{Hh0",
    "ODXM^3[R{4zkLq8%AYU@x}HdIrGt6]e9N!Fsb#gKiEa17WZvlp2m|JnTcwfQou5P",
    "M@bKEvcJqC4eW{26IAL7FaHOzd}&f098]mgkj1DRPBxoGnZQwyu[si$|hU!3NYrT",
    "vFneSkm@LHBOjQ#shVu{NW0wX}b6aIl[2tzMR1gqrKDoAi5yEcfC$U|Gd^8%J3p!",
    "S9n!FIjDlC582[HBfQJdL0aN7Tcyom@K{VX$vAUqk6szePw&|GuY#bOpi%M]4t^Z",
    "9fAbRC[gvj]86dlq^cB2h$y%}S&IKaMQ5rDH|37!{Z#PFnkt1VumEeOGsTLNoiw4",
    "4wW|Xv8bgdxchM^EFkm7{%V1JR!PIt[r3a2z9HT50]$lBGnOYZoULu&@AijKNes}",
    "[eMXv1iuaQ@Lq8fm7c2lBAb6#r9R$g]ZxW|53UC^Epsn%NY}jz4T!HJ&Od{KPVot",
    "TvME6Q5aGhm9C7DL$IOkw4Znu|[&{@N2%pbjdWlJzx3BP!cF1e8]}#tyoSfX0sAY"
  };
  private static final int PERM_ARRAY_CHECKSUM = 173858;
  private static final int ROLL_PERM_ARRAY = 27;

  private static final int[] HEX_ARRAY = {
    0, 17, 8, 21, 23, 6, 16, 20,
    13, 4, 11, 26, 30, 22, 27, 3,
    5, 15, 9, 14, 18, 25, 10, 19,
    31, 1, 2, 12, 7, 28, 24, 29
  };


  MatrixZeptoVIEWPro() {}

  public String[] getPermArray()
  {
    return this.PERM_ARRAY;
  }

  public int getPermArrayChecksum()
  {
    return this.PERM_ARRAY_CHECKSUM;
  }

  public int getRollPermArray()
  {
    return this.ROLL_PERM_ARRAY;
  }

  public int[] getHexArray()
  {
    return this.HEX_ARRAY;
  }
}
