package jlk;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class RegisterDialog extends JDialog
{
   boolean cancelled = true;
   boolean setInitialFocus = true;

   public RegisterDialog(Frame parent)
   {
      super(parent, true);
      //{{INIT_CONTROLS
      setVisible(false);
      getContentPane().setLayout(new BorderLayout(0,0));
      setSize(468,188);
      topPanel.setLayout(new GridBagLayout());
      getContentPane().add("North", topPanel);
      titleLabel.setText(" Registration");
      try {
         titleLabel.setIcon(new ImageIcon(getClass().getResource("appIcon.gif")));
      }
      catch(Exception e) {
        e.printStackTrace();
      }
      topPanel.add(titleLabel, new GridBagConstraintsD(0,0,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(16,16,8,16),0,0));
      titleLabel.setFont(new Font("Dialog", Font.BOLD, 24));
      midPanel.setLayout(new GridBagLayout());
      getContentPane().add("Center", midPanel);
      keyLabel.setText("License String:");
      midPanel.add(keyLabel, new GridBagConstraintsD(0,0,1,1,0.0,1.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,16,0,8),4,2));
      keyField.setText("XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX");
      midPanel.add(keyField, new GridBagConstraintsD(1,0,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,16),12,4));
      keyField.setFont(new Font("DialogInput", Font.PLAIN, 12));
      nameLabel.setText("Name or Organisation:");
      midPanel.add(nameLabel, new GridBagConstraintsD(0,1,1,1,0.0,1.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(4,16,0,8),4,2));
      nameField.setText("ACME Inc.");
      midPanel.add(nameField, new GridBagConstraintsD(1,1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(4,0,0,16),12,4));
      nameField.setFont(new Font("DialogInput", Font.PLAIN, 12));
      bottomPanel.setLayout(new GridBagLayout());
      getContentPane().add("South",bottomPanel);
      registerButton.setText("Register Application");
      registerButton.setActionCommand("Register Application");
      bottomPanel.add(registerButton, new GridBagConstraintsD(0,0,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(16,16,16,16),0,0));
      cancelButton.setText("Cancel");
      cancelButton.setActionCommand("Cancel");
      bottomPanel.add(cancelButton,new GridBagConstraintsD(1,0,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(16,0,16,16),0,0));
      //}}

      //{{REGISTER_LISTENERS
      SymAction lSymAction = new SymAction();
      cancelButton.addActionListener(lSymAction);
      registerButton.addActionListener(lSymAction);
      SymWindow aSymWindow = new SymWindow();
      this.addWindowListener(aSymWindow);
      SymFocus aSymFocus = new SymFocus();
      keyField.addFocusListener(aSymFocus);
      nameField.addFocusListener(aSymFocus);
      SymKey aSymKey = new SymKey();
      keyField.addKeyListener(aSymKey);
      nameField.addKeyListener(aSymKey);

      java.util.ResourceBundle b = LicenseHandler.getLicenseStrings();
      titleLabel.setText(b.getString("REGISTER_TITLE"));
      keyLabel.setText(b.getString("REGISTER_KEY"));
      nameLabel.setText(b.getString("REGISTER_NAME"));
      registerButton.setText(b.getString("REGISTER_REGISTER"));
      cancelButton.setText(b.getString("REGISTER_CANCEL"));
      //}}
   }

   public RegisterDialog()
   {
      this((Frame)null);
   }

   public void runModal ()
   {
      String key = getKey();
      setKey("XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX");
      pack();
      setKey(key);

      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      int x = (screenSize.width - getSize().width) / 2;
      int y = (int)((screenSize.height - getSize().height) / 2.5);
      setLocation(x, y);

      cancelled = true;
      setInitialFocus = true;

      setVisible(true);
   }

   protected JRootPane createRootPane()
   {
      escapeListener = new ActionListener() {
         public void actionPerformed(ActionEvent actionEvent) {
            setVisible(false);
         }
      };
      JRootPane rootPane = new JRootPane();
      rootPane.registerKeyboardAction(escapeListener,
         KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0),
         JComponent.WHEN_IN_FOCUSED_WINDOW);
      return rootPane;
   }
   ActionListener escapeListener;

   public void addNotify()
   {
      // Record the size of the window prior to calling parents addNotify.
      Dimension size = getSize();

      super.addNotify();

      if (frameSizeAdjusted)
         return;
      frameSizeAdjusted = true;

      // Adjust size of frame according to the insets
      Insets insets = getInsets();
      setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);
   }

   // Used by addNotify
   boolean frameSizeAdjusted = false;

   //{{DECLARE_CONTROLS
   JPanel topPanel = new JPanel();
   JLabel titleLabel = new JLabel();
   JPanel midPanel = new JPanel();
   JLabel keyLabel = new JLabel();
   JTextField keyField = new JTextField();
   JLabel nameLabel = new JLabel();
   JTextField nameField = new JTextField();
   JPanel bottomPanel = new JPanel();
   JButton registerButton = new JButton();
   JButton cancelButton = new JButton();
   //}}

   class SymAction implements java.awt.event.ActionListener
   {
      public void actionPerformed(java.awt.event.ActionEvent event)
      {
         Object object = event.getSource();
         if (object == cancelButton)
            cancelButton_actionPerformed(event);
         else if (object == registerButton)
            registerButton_actionPerformed(event);
      }
   }

   void cancelButton_actionPerformed(java.awt.event.ActionEvent event)
   {
      setVisible(false);
   }

   void registerButton_actionPerformed(java.awt.event.ActionEvent event)
   {
     cancelled = false;
     setVisible(false);
   }

   public String getKey ()
   {
      return keyField.getText();
   }

   public void setKey (String aString)
   {
      keyField.setText(aString);
   }

   public String getName ()
   {
      return nameField.getText();
   }

   public void setName (String aString)
   {
      nameField.setText(aString);
   }

   public boolean wasCancelled ()
   {
      return cancelled;
   }

   class SymWindow extends java.awt.event.WindowAdapter
   {
      public void windowActivated(java.awt.event.WindowEvent event)
      {
         Object object = event.getSource();
         if (object == RegisterDialog.this)
            RegisterDialog_windowActivated(event);
      }

      public void windowOpened(java.awt.event.WindowEvent event)
      {
         Object object = event.getSource();
         if (object == RegisterDialog.this)
            RegisterDialog_windowOpened(event);
      }
   }

   void RegisterDialog_windowOpened(java.awt.event.WindowEvent event)
   {
      if (setInitialFocus) {
         keyField.requestFocus();
         setInitialFocus = false;
      }
   }

   void RegisterDialog_windowActivated(java.awt.event.WindowEvent event)
   {
      if (setInitialFocus) {
         keyField.requestFocus();
         setInitialFocus = false;
      }
   }

   class SymFocus extends java.awt.event.FocusAdapter
   {
      public void focusLost(java.awt.event.FocusEvent event)
      {
         Object object = event.getSource();
         if (object == keyField)
            keyField_focusLost(event);
         else if (object == nameField)
            nameField_focusLost(event);
      }

      public void focusGained(java.awt.event.FocusEvent event)
      {
         Object object = event.getSource();
         if (object == keyField)
            keyField_focusGained(event);
         else if (object == nameField)
            nameField_focusGained(event);
      }
   }

   void keyField_focusLost(java.awt.event.FocusEvent event)
   {
      keyField.select(0,0);
   }

   void nameField_focusLost(java.awt.event.FocusEvent event)
   {
      nameField.select(0,0);
   }

   void keyField_focusGained(java.awt.event.FocusEvent event)
   {
      keyField.selectAll();
   }

   void nameField_focusGained(java.awt.event.FocusEvent event)
   {
      nameField.selectAll();
   }

   class SymKey extends java.awt.event.KeyAdapter
   {
      public void keyPressed(java.awt.event.KeyEvent event)
      {
         Object object = event.getSource();
         if (object == keyField)
            keyField_keyPressed(event);
         else if (object == nameField)
            nameField_keyPressed(event);
      }
   }

   void keyField_keyPressed(java.awt.event.KeyEvent event)
   {
      if (event.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
         nameField.requestFocus();
      }
   }

   void nameField_keyPressed(java.awt.event.KeyEvent event)
   {
      if (event.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
         registerButton.requestFocus();
      }
   }
}